C
$LARGE
C   VERSION 2.4 5/11/87    SOURCE CODE FOR MULTICORR
C   NOTE--PROGRAM IS DESIGNED TO RUN ON LARGE MAINFRAMES
C   SUBSTANTIAL REDUCTION IN CORE REQUIREMENTS CAN BE OBTAINED BY
C   REDIMENSIONING THE PROGRAM.  THE PROGRAM IS CURRENTLY DIMENSIONED
C   TO HANDLE CORRELATION MATRICES OF SIZE  18x18  OR LESS.KEY DIMENSIONS
C   ARE LA, CURRENTLY  20, AND LB,CURRENTLY  153= 18*( 18-1)/2.
C   LA IS THE ORDER OF THE LARGEST CORRELATION MATRIX TO BE PROCESSED, AND
C   LB=LA*(LA-1)/2.
C   LA(CURRENTLY  18) APPEARS ON LINES 14,29,233,308,309,311
C
C   (CURRENTLY  153) APPEARS ON LINES  14,30,
C   308,309,310,311 (see multicor.lst for line numbers)
      DIMENSION R(18,18),PAR(153,4)
      CHARACTER*80 TITLE,FILEIN,FILEOP
C        ***********************************************************
C        *   NV=NUMBER OF VARIABLES                                *
C        *   N=NUMBER OF OBSERVATIONS                              *
C        *   NPC=# OF CONSTRAINED PARAMETERS (SEE INSTRUCTIONS)    *
C        *   NOUTP=OUTPUT PARAMETER   0=STANDARD OUTPUT            *
C        *                            9876=FULL OUTPUT             *
C        ***********************************************************
    1 FORMAT(10I5)
    2 FORMAT(1X,/,' NUMBER OF VARIABLES =',I5,5X,'N=',I5,
     1/,' NUMBER OF CONSTRAINED PARAMETERS=',I5)
    4 FORMAT(A80)
    6 FORMAT(3F5.0,F10.0)
   44 FORMAT(1X,/,1X,A80)
      LA=18
      LB=153
      NIN=5
      NOUT=6
C ** Note that the enclosed lines are to obtain unit names
C ** for the Microsoft Fortran Version
C ** Some system specific modifications may be necessary for
C ** establishing input and output units.
      WRITE(*,771)
 771  FORMAT(' Multicor 2.4 -- Dimensioned for 18x18 maximum')
      WRITE(*,7)
    7 FORMAT(' Please type the name of your input file.')
      READ(5,4) FILEIN
      WRITE(*,77)
   77 FORMAT (' Please type the name of your output file or device.')
      READ(5,4)FILEOP
      OPEN(UNIT=NIN, FILE=FILEIN)
      OPEN(UNIT=NOUT, FILE=FILEOP)
C End of Microsoft specific code
C ************************************
      WRITE(NOUT,111)
  111 FORMAT(1X,/,' *************************************************')
      WRITE(NOUT,112)
  112 FORMAT(1X,/,' *  PROGRAM MULTICORR - VERSION 2.4 - MAY 1987   *')
      WRITE(NOUT,113)
  113 FORMAT(1X,/,' *                     BY                        *')
      WRITE(NOUT,114)
  114 FORMAT(1X,/,' *               JAMES H. STEIGER                *')
      WRITE(NOUT,115)
  115 FORMAT(1X,/,' *        UNIVERSITY OF BRITISH COLUMBIA         *')
      WRITE(NOUT,116)
  116 FORMAT(1X,/,' *              DEPT OF PSYCHOLOGY               *')
      WRITE(NOUT,117)
  117 FORMAT(1X,/,' *************************************************')
      READ(NIN,4)TITLE
      WRITE(NOUT,44)TITLE
      READ(NIN,1)NV,N,NPC,NOUTP
      WRITE(NOUT,2)NV,N,NPC
      IF(NOUTP.EQ.9876)WRITE(NOUT,222)
  222 FORMAT(1X,/,' FULL OUTPUT REQUESTED')
      IF (NOUTP.NE.9876)WRITE(NOUT,223)
  223 FORMAT(1X,/,' STANDARD OUTPUT REQUESTED')
      CALL READI(NV,NV,R,LA,NIN)
      DO 101 J=2,NV
      J2=J-1
      DO 101 I=1,J2
  101 R(I,J)=R(J,I)
      CALL TRITE(NV,NV,R,LA,NOUT,0,7,' INPUT CORRELATION MATRIX   ')
      DO 10 I=1,NPC
   10 READ(NIN,6)(PAR(I,J),J=1,4)
      CALL TRITE(NPC,4,PAR,LB,NOUT,0,5,' HYPOTHESIS MATRIX  ')
      CALL GLS(PAR,NV,LA,NPC,CHI,R,N,LB,NOUTP,NQ,NOUT)
      DF=NV*(NV-1)/2-NQ
      WRITE(NOUT,99)
   99 FORMAT(1X,/,1X, 'END OF PROGRAM')
      STOP
      END
      FUNCTION ZTRAN(R)
      ZTRAN=.5*ALOG((1.+R)/(1.-R))
      RETURN
      END
      SUBROUTINE GMULT(A,B,C,M,N,L,NDIMA,NDIMB,NDIMC)
      DIMENSION A(NDIMA,1),B(NDIMB,1),C(NDIMC,1)
      REAL*8 SUM
      DO 1 J=1,L
      DO 1 I=1,M
      SUM=0.D0
      DO 2 K=1,N
   2  SUM=SUM+A(I,K)*B(K,J)
   1  C(I,J)=SUM
      RETURN
      END
      SUBROUTINE FINV(N,NDIMT,T1,IP,NDIMA,A,DET,IEXP,COND)
C *** INVERT A MATRIX TAKING PAGING INTO CONSIDERATION I.E.
C *** OPERATIONS DONE BY COLUMNS.
C *** INPUT PARAMETERS
C *** N ORDER OF MATRIX
C *** NDIMT 1ST DIMENSION OF ARRAY T1
C *** T1 TWO DIMENSIONAL ARRAY CONTAINS THE MATRIX IN LEFT UPPER
C ***      CORNER
C *** NDIMA 1ST DIMENSION OF ARRAY A
C *** OUTPUT PARAMETERS
C *** T1 CONTAINS THE ORIGINAL MATRIX
C *** IP INTEGER ONE DIMENSIONAL ARRAY CONTAIN INTERCHANGE INFO
C *** A  TWO DIMENSIONAL ARRAY CONTAINS THE INVERSE MAY EQUAL T1
C *** DET,IEXP DETERMINANT=DET*10**IEXP
C *** COND CONTAINS THE TURING CONDITION NUMBER
      DIMENSION A(NDIMA,1),IP(1),T1(NDIMT,1)
      REAL*8 DSQRT,CSUMA,CSUMB,TA
         DO 30 J=1,N
         DO 30 I=1,N
30       A(I,J)=T1(I,J)
      IEXP=0
      IF(N.EQ.1) GO TO 1991
C     IP(K) WILL KEEP TRACK OF WHICH ROW ENDS UP AS K*TH PIVOT ROW
      DET=1.0
C     FIRST PART OF COND
      KSW=1
      GO TO 260
45    CSUMA=CSUMB
C     INVERSION STARTS
         DO 199 K=1,N
C     FIND MAXIMUM ELEMENT IN K*TH COLUMN
         AMAX=ABS(A(K,K))
         IMAX=K
         IF(K.EQ.N) GO TO 65
50       KP=K+1
            DO 60 I=KP,N
            AIK=ABS(A(I,K))
            IF (AIK.LE.AMAX) GO TO 60
55          AMAX=AIK
            IMAX=I
60          CONTINUE
C     TEST FOR SINGULARITY
65       IF (AMAX.EQ.0.) GO TO 300
C     INTERCHANGE ROWS K AND IMAX
         IP(K)=IMAX
         IF (K.EQ.IMAX) GO TO 100
         DET=-DET
C     COMPUTE DETERMINANT
100      DET=DET*A(IMAX,K)
         QDET=ABS(DET)
         IF (QDET.LT.1.E15) GO TO 701
         DET=DET*1.E-15
         IEXP=IEXP+15
701      IF (QDET.GT.1.E-15) GO TO 750
         DET=DET*1.E15
         IEXP=IEXP-15
C     DIVIDE K*TH ROW BY A(K,K)
750      T=1./A(IMAX,K)
         A(IMAX,K)=A(K,K)
         A(K,K)=-1.0
            DO 1999 I=1,N
            A(I,K)=-A(I,K)*T
1999        CONTINUE
            DO 144 J=1,N
            IF (J.EQ.K) GO TO 144
C      INTERCHANGE ROWS K AND IMAX
           TEMP=A(IMAX,J)
            IF (K.EQ.IMAX) GO TO 140
            A(IMAX,J)=A(K,J)
75          A(K,J)=TEMP
C     DIVIDE K*TH ROW BY A(K,K)
140         A(K,J)=TEMP*T
C     SUBTRACT A(I,K) TIMES K*TH ROW FROM OTHER ROWS
               DO 109 I=1,N
               IF (I.EQ.K) GO TO 109
               A(I,J)=A(I,J)+TEMP*A(I,K)
109            CONTINUE
144         CONTINUE
199      CONTINUE
C     RESTORE PROPER COLUMN ORDER IN THE INVERSE
      NM1=N-1
         DO 250 KK=1,NM1
         K=N-KK
C     COLUMN NOW IN K*TH POSITION ACTUALLY COLUMN......
210      J=IP(K)
C     ... OF THE INVERSE. THEREFORE......
         IF (J.EQ.K) GO TO 250
C     RELOCATE COLUMN K TO POSITION J
220         DO 225 I=1,N
            T=A(I,J)
            A(I,J)=A(I,K)
225         A(I,K)=T
250      CONTINUE
      KSW=2
C     CALCULATE COND
260   CSUMB=0.0D0
         DO 271 J=1,N
            DO 270 I=1,N
            TA=A(I,J)
            CSUMB=CSUMB+TA*TA
270         CONTINUE
271      CONTINUE
      GO TO (45,275), KSW
275   FN=N
      COND=DSQRT(CSUMA*CSUMB)/FN
      RETURN
C     PROCEDURE FOR SINGULAR OR NEARLY SINGULAR MATRIX.
300   WRITE(*,310) K,AMAX
310   FORMAT (1X,/,4HSTEP,I3,9H  PIVOT =,E18.8,25H   INVERSION DISCONTIN
     1UED/)
      DET=0.0
      IEXP=0
      COND=0.0
      RETURN
C *** CODE FOR ORDER 1
 1991 IF (A(1,1).EQ.0.) GO TO 1992
      DET=A(1,1)
      A(1,1)=1./A(1,1)
      COND=1.
      RETURN
1992  K=1
      AMAX=0.
      GO TO 300
      END
      SUBROUTINE TRANS(Z,NRX,NCX,XTRANS,L1,L2)
      DIMENSION Z(L1,L2),XTRANS(L2,L1)
      DO 10 I=1,NRX
      DO 10 J=1,NCX
   10 XTRANS(J,I)=Z(I,J)
      RETURN
      END
      SUBROUTINE CDELT(DELTA,NQ,PAR,LA,LB,NPC,NV,NV2)
      DIMENSION DELTA(LB,LB),PAR(LB,4),NR(18,18)
      XKTOP=0.
      DO 10 I=1,NPC
   10 IF (PAR(I,3).GT.XKTOP)XKTOP=PAR(I,3)
      KTOP=XKTOP
      NQ=(NV*(NV-1)/2)-NPC+KTOP
      NV2=NV*(NV-1)/2
      IF(NQ.EQ.0)RETURN
      DO 20 I=1,NV2
      DO 20 J=1,NQ
   20 DELTA(I,J)=0.
      DO 30 I=1,NV
      DO 30 J=1,NV
   30 NR(I,J)=0.
      DO 40 I=1,NPC
      II=PAR(I,1)
      JJ=PAR(I,2)
      NR(II,JJ)=PAR(I,3)
      IF(NR(II,JJ).EQ.0)NR(II,JJ)=-1
   40 NR(JJ,II)=NR(II,JJ)
      DO 50 I=1,NV
      DO 50 J=1,NV
      IF(I.GE.J)GO TO 50
      IF(NR(I,J).NE.0)GO TO 50
      KTOP=KTOP+1
      NR(I,J)=KTOP
      NR(J,I)=KTOP
   50 CONTINUE
      DO 55 I=1,NV
      DO 55 J=1,NV
   55 IF(NR(I,J).EQ.-1)NR(I,J)=0
      II=0
      DO 60 I=2,NV
      I2=I-1
      DO 60 J=1,I2
      II=II+1
      IF(NR(I,J).EQ.0)GO TO 60
      JJ=NR(I,J)
      DELTA(II,JJ)=1.
   60 CONTINUE
      RETURN
      END
      SUBROUTINE CMAT(R,VECR,LA,LB,NV,NV2)
      DIMENSION R(LA,LA),VECR(LB)
      II=0
      DO 10 I=2,NV
      I2=I-1
      DO 10 J=1,I2
      II=II+1
   10 R(I,J)=VECR(II)
      DO 20 I=1,NV
   20 R(I,I)=1.
      DO 30 J=2,NV
      J2=J-1
      DO 30 I=1,J2
   30 R(I,J)=R(J,I)
      RETURN
      END
      SUBROUTINE CPSTAR(PSTAR,NV2,NV,LA,PAR,LB,NPC)
      DIMENSION PSTAR(LB),PAR(LB,4)
      II=0
      DO 10 I=1,NV2
   10 PSTAR(I)=0.
      III=0
      DO 20 I=2,NV
      J2=I-1
      DO 20 J=1,J2
      III=III+1
      DO 15 II=1,NPC
   15 IF((PAR(II,1).EQ.I).AND.(PAR(II,2).EQ.J).AND.(PAR(II,3).EQ.0))
     1PSTAR(III)=PAR(II,4)
   20 CONTINUE
      RETURN
      END
      SUBROUTINE GLS(PAR,NV,LA,NPC,CHI,R,N,LB,NOUTP,NQ,NOUT)
      DIMENSION GAM(153),RO(153),PSTAR(153),VECR(153),R(18,18)
      DIMENSION DELTA(153,153),IPERM(153),T(18,18),SIGINV(153,153)
      DIMENSION D(153),DT(153,153),DTSI(153,153),DSD(153,153),DH(153,1)
      DIMENSION RBAR(18,18),RMIN(153),PAR(LB,4)
      XN=N
      CALL CDELT(DELTA,NQ,PAR,LA,LB,NPC,NV,NV2)
      CALL CPSTAR(PSTAR,NV2,NV,LA,PAR,LB,NPC)
C  ******  COMPUTE OLS ESTIMATES IF NEEDED  ********
      DO 20 I=1,NQ
   20 GAM(I)=0.
      II=0
      DO 30 I=2,NV
      I2=I-1
      DO 30 J=1,I2
      II=II+1
   30 VECR(II)=R(I,J)
      IF(NQ.NE.0)GO TO 11
      DO 10 I=1,NV2
   10 RO(I)=PSTAR(I)
      GO TO 75
   11 CONTINUE
      DO 40 I=1,NQ
      DO 40 J=1,NV2
   40 GAM(I)=GAM(I)+VECR(J)*DELTA(J,I)
      DO 50 I=1,NQ
      SUM=0
      DO 45 J=1,NV2
   45 SUM=SUM+DELTA(J,I)
   50 GAM(I)=GAM(I)/SUM
      DO 70 I=1,NV2
      RO(I)=0.
      DO 60 J=1,NQ
   60 RO(I)=RO(I)+DELTA(I,J)*GAM(J)
   70 RO(I)=RO(I)+PSTAR(I)
   75 CALL CMAT(RBAR,RO,LA,LB,NV,NV2)
      CALL TRITE(NV,NV,RBAR,LA,NOUT,0,6,' MATRIX OF OLS ESTIMATES')
   72 FORMAT(1X,/,' INVERSE OF MATRIX OF OLS ESTIMATES')
C  ************ INVERT RBAR, PLACE INVERSE IN R************
      CALL FINV(NV,LA,RBAR,IPERM,LA,R,DET,JEXP,COND)
      IF (DET.EQ.0)WRITE(NOUT,73)
   73 FORMAT(1X,/,' **PROGRAM ERROR-MATRIX OF OLS ESTIMATES IS SINGULAR-*
     1*')
      IF (DET.EQ.0)WRITE(NOUT,731)
  731 FORMAT(1X,' ******EXECUTION SUSPENDED******')
      IF(DET.EQ.0)STOP
      IF (NOUTP.EQ.9876)CALL TRITE(NV,NV,R,LA,NOUT,0,9,
     >' INVERSE OF MATRIX OF OLS ESTIMATES ')
C   ******COMPUTE MATRIX T--SEE JENNRICH, 1970, JASA*********
      IF(NOUTP.EQ.9876)WRITE(NOUT,11111)COND
      DO 90 I=1,NV
      DO 90 J=1,NV
      DDD=0.
      IF(I.EQ.J)DDD=1.
   90 T(I,J)=DDD+RBAR(I,J)*R(I,J)
C*****COMPUTE INVERSE OF ESTIMATED VAR-COVAR MTX OF CORRELATION VECTOR***
      IF(NOUTP.EQ.9876)CALL TRITE(NV,NV,T,LA,NOUT,0,3,' MATRIX T   ')
      CALL FINV(NV,LA,T,IPERM,LA,T,DET,JEXP,COND)
C   ********INVERT T IN PLACE************
      IF(NOUTP.EQ.9876)CALL TRITE(NV,NV,T,LA,NOUT,0,5,
     >' INVERSE OF MATRIX T')
      IF(NOUTP.EQ.9876)WRITE(NOUT,11111)COND
11111 FORMAT(' CONDITION NUMBER IS ',E16.7)
C     *******COMPUTE INVERSE USING JENNRICH FORMULAS********
      II1=0
      DO 120 I=2,NV
      I2=I-1
      DO 120 J=1,I2
      II1=II1+1
      II2=0
      DO 120 K=2,NV
      K2=K-1
      DO 120 L=1,K2
      II2=II2+1
      D(II2)=1-RBAR(K,L)**2
  120 SIGINV(II1,II2)=R(I,K)*R(J,L)+R(I,L)*R(J,K)-(R(I,J)*
     1(T(I,K)+T(J,K)+T(I,L)+T(J,L))*R(K,L))
      IF (NOUTP.EQ.9876)CALL TRITE(NV2,NV2,SIGINV,LB,NOUT,0,13,
     >'INVERSE VAR-COVAR MATRIX OF RAW CORRELATION VECTOR   ')
      IF(NQ.EQ.0)GO TO 399
      CALL TRANS(DELTA,NV2,NQ,DT,LB,LB)
      CALL GMULT(DT,SIGINV,DTSI,NQ,NV2,NV2,LB,LB,LB)
      DO 200 I=1,NV2
  200 RMIN(I)=VECR(I)-PSTAR(I)
      CALL GMULT(DTSI,RMIN,DH,NQ,NV2,1,LB,LB,LB)
      CALL GMULT(DTSI,DELTA,DSD,NQ,NV2,NQ,LB,LB,LB)
      CALL FINV(NQ,LB,DSD,IPERM,LB,DSD,DET,JEXP,COND)
      CALL GMULT(DSD,DH,GAM,NQ,NQ,1,LB,LB,LB)
C    ******PLACE GLS ESTIMATES IN RBAR,RO************
      DO 300 I=1,NV2
      RO(I)=0.
      DO 290 J=1,NQ
  290 RO(I)=RO(I)+DELTA(I,J)*GAM(J)
  300 RO(I)=RO(I)+PSTAR(I)
      CALL CMAT(RBAR,RO,LA,LB,NV,NV2)
      CALL TRITE(NV,NV,RBAR,LA,NOUT,0,6,' MATRIX OF GLS ESTIMATES')
C   *******COMPUTE QUADRATIC FORM CHI-SQUARE**********
  399 CONTINUE
      DO 400 I=1,NV2
      VECR(I)=ZTRAN(VECR(I))
  400 RO(I)=ZTRAN(RO(I))-VECR(I)
      CHI=0.
      DO 500 I=1,NV2
      DO 500 J=1,NV2
      SIGINV(I,J)=SIGINV(I,J)*D(I)*D(J)
  500 CHI=CHI+RO(I)*RO(J)*SIGINV(I,J)
      CHI=CHI*(XN-3.)
      IF (NOUTP.NE.9876)GO TO 600
      CALL TRITE(NV2,1,RO,LB,NOUT,0,10,
     >' DIFFERENCE VECTOR OF FISHER TRANSFORMS ')
      CALL TRITE(NV2,NV2,SIGINV,LB,NOUT,0,12,
     >' INVERSE OF VAR-COVAR MTX OF FISHER TRANSFORMS  ')
  600 CONTINUE
      DF=NV2-NQ
      CALL WHZ(CHI,DF,ZZZ)
      CALL ZPROB(ZZZ,ZP)
      WRITE(NOUT,601)CHI,DF,ZP
  601 FORMAT(1X,/,' CHI SQUARE =',F10.4,5X,'DF=',F5.0,5X,'P=',F6.4)
      RETURN
      END
      SUBROUTINE WHZ(CHISQ,DF,Z)
      IF (DF.LE.0.)Z=0.
      IF (DF.LE.0.)RETURN
      FRAC2=2./(9.*DF)
      FRAC=1./3.
      Z=(CHISQ/DF)**FRAC
      Z=Z-1.+FRAC2
      Z=Z/SQRT(FRAC2)
      RETURN
      END
      SUBROUTINE ZPROB(Z,ZP)
C  RETURNS AS ZP THE AREA TO THE RIGHT OF Z UNDER A STANDARD NORMAL CURVE
      C1=.196854
      C2=.115194
      C3=.000344
      C4=.019527
      FLAG=0.
      IF(Z.LT.0.)FLAG=1.
      IF(Z.LT.0.)Z=-Z
      ZP=1.+(C1*Z)+(C2*Z*Z)+(C3*Z*Z*Z)+(C4*Z*Z*Z*Z)
      ZP=ZP**4
      ZP=ZP*2.
      ZP=1./ZP
      IF(FLAG.EQ.1.)ZP=1.-ZP
      IF (FLAG.EQ.1.)Z=-Z
      RETURN
      END
      SUBROUTINE READI(NROW,NCOL,A,LA,NIN)
      DIMENSION A(LA,1)
      CHARACTER*80 FMT
C ********* READ ROUTINE FOR WHOLE MATRICES ************
      READ (NIN,202)FMT
      DO 10 I=1,NROW
      READ (NIN,FMT)(A(I,J),J=1,NCOL)
  10  CONTINUE
 201  FORMAT(2I3)
  202 FORMAT(A80)
      RETURN
      END
C
      SUBROUTINE TRITE(NROW,NCOL,A,LA,NOUT,LF,LT,TEXT)
      DIMENSION A(LA,*),FMT(20),TEXT(20)
C ******** WRITE REAL WHOLE MATRIX WITH TEXT HEADER *****
      CHARACTER*4 TEXT
      WRITE(NOUT,1)LF,(TEXT(I),I=1,LT)
    1 FORMAT(I1,10X,20A4)
      LL=NCOL-(NCOL/10)*10
      IF(LL) 2,2,3
  3   LL=1
  2   LL=(NCOL/10)+LL
      K=0
      DO 10 II=1,LL
      N0=K+1
      N1=K+10
      N1= MIN0 (N1,NCOL)
      WRITE(NOUT,202)(J,J=N0,N1)
      DO 8 I=1,NROW
      WRITE(NOUT,203)I,(A(I,J),J=N0,N1)
    8 CONTINUE
      K=K+10
  10  CONTINUE
 202  FORMAT(1H-,3X,10I11)
 203  FORMAT(1H,,I3,3X,10F11.4)
      RETURN
      END
